using System;
using System.Collections;
using System.Collections.Generic;

class g
{
    static public int br, n, k;
    static public int[] a, b;
}

class HelloWorld
{
    static void racunaj(int[] a, int l, int d)
    {
        if (l+1== d)
        {
            int x = Math.Max(a[l]-a[d],a[d]-a[l]);
            if (g.br < x) g.br = x;
        }
        else
        {
            int[] a1 = new int[g.k];
            int[] a2 = new int[g.k];
            for (int i = 0; i < g.k; i++)
            {
                a1[i] = a[i];
                a2[i] = a[i];
            }
            a2[l] -= a2[d];
            racunaj(a2, l, d - 1);
            a1[d] -= a1[l];
            racunaj(a1, l + 1, d);
        }
    }
    static void komb(int[] b, int br, int j)
    {
        if (br == g.k)
        {
            racunaj(b, 0, g.k - 1);
        }
        else
        {
            for (int i = j; i < g.n; i++)
            {
                b[br] = g.a[i];
                komb(b, br + 1, i + 1);
            }
        }
    }
    static void Main()
    {
        g.br = -2000000000;
        string[] s = Console.ReadLine().Split(' ');
        g.n = int.Parse(s[0]);
        g.k = int.Parse(s[1]);
        g.a = new int[g.n];
        int[] b = new int[g.k];
        s = Console.ReadLine().Split(' ');
        for (int i = 0; i < g.n; i++)
        {
            g.a[i] = int.Parse(s[i]);
        }
        komb(b, 0, 0);
        Console.WriteLine(g.br);
    }
}